This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 785946 - Review Request: python-django-horizon - Django application for talking to Openstack
Review Request: python-django-horizon - Django application for talking to Ope...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Matthias Runge
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-01-30 19:31 EST by Cole Robinson
Modified: 2012-04-05 08:10 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-02-06 20:10:33 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
mrunge: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Cole Robinson 2012-01-30 19:31:29 EST
Spec URL: http://fedorapeople.org/~crobinso/reviews/django-horizon.spec
SRPM URL: http://fedorapeople.org/~crobinso/reviews/django-horizon-2012.1-0.1.e3.fc16.src.rpm
Description: Horizon is a Django application for providing Openstack UI components. It allows performing site administrator (viewing account resource usage, configuring users, accounts, quotas, flavors, etc.) and end user
operations (start/stop/delete instances, create/restore snapshots, view
instance VNC console, etc.)

The package also contains an openstack-dashboard subpackage, which is some themeing and javascript around horizon that makes up the Openstack web UI reference implementation.

Some notes on current package state:

1) Deps like python-quantumclient and python-keystoneclient are in git and built, but not in rawhide as of this writing. A mock build will fail

2) An upstream patch is provided that removes the openstackx python module dependency: this missed the upstream release by a day.

3) A patch is included to remove a hard requirement on the unpackaged django-nose, which is only used for horizon tests.

4) The package works if you use a django style manage.py script, and the httpd+wsgi integration allows the dashboard to start up, but I can't log in. Some debugging shows that we are successfully authenticating, but it seems like the code is reinvoked several times which stomps our http_session ID and and horizon forgets about our authentication before we can advance to the next screen. I'll be debugging this further but figured this review can help parallelize a bit.
Comment 1 Matthias Runge 2012-01-31 02:37:00 EST
Please note bug https://bugzilla.redhat.com/show_bug.cgi?id=736776
requesting name change of all (python-)django-packages. 

There was a discussion on python-devel-list. Name change shall take place right after f17 was branched, please refer to

http://lists.fedoraproject.org/pipermail/python-devel/2012-January/000335.html
Comment 2 Cole Robinson 2012-02-01 10:53:27 EST
Spec URL: http://fedorapeople.org/~crobinso/reviews/python-django-horizon.spec
SRPM URL: http://fedorapeople.org/~crobinso/reviews/python-django-horizon-2012.1-0.1.e3.fc16.src.rpm

Changes since v1:
- Changed name to python-django-horizon
- Changes to http conf to make it all actually work (thanks to dhiggins)
- Deps are in rawhide so mock build now works

Current RPMlint

openstack-dashboard.noarch: W: no-documentation

Not a blocker IMO

openstack-dashboard.noarch: E: python-bytecode-inconsistent-mtime /usr/share/openstack-dashboard/local/local_settings.pyc 2012-02-01T10:42:39 /etc/openstack-dashboard/local_settings 2012-02-01T10:42:55

I don't know what to do about this: /usr/share/openstack-dashboard/local/local_settings.py is a symlink to /etc/openstack-dashboard/local_settings.py. Seems to cause the mtimes to get confused. Long run I want to enable this behavior in upstream, but for now this seems like a reasonable hack. I don't think the above problem should cause any problems AFAIK.

python-django-horizon.noarch: W: no-documentation

Not a blocker IMO (though there is a doc subpackage...)

python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/instances/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/flavors/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/services/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/nova/instances_and_volumes/volumes/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/images/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/quotas/tests.py

This stubs need to be there to appease upstream tests. We could rip them out
with a patch but that sounds more dangerous than the alternative of just leaving them in.

python-django-horizon.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/horizon/dashboards/settings/templates/settings/tenant/openrc.sh.template 0644L /bin/bash

This file is actually a template that is used to generate a bash script that is shown to the user in the UI for them to copy to a local file and run. As such it shouldn't be executable, but it should have the #!/bin/bash header that causes rpmlint to think it should be a script. So not a blocker IMO
Comment 3 Matthias Runge 2012-02-06 13:53:56 EST
I'll do a review.
Comment 4 Cole Robinson 2012-02-06 14:20:38 EST
Thanks Matthias! FYI this package is associated with an F17 feature:

http://fedoraproject.org/w/index.php?title=Features/OpenStack_Horizon

 so I was ideally hoping that it would be committable by tomorrow (F17 feature freeze), but I can probably get an extension if that isn't feasible
Comment 5 Matthias Runge 2012-02-06 14:43:37 EST
Phew, this may get a little tough


Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST %config files are marked noreplace or the reason is justified.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[!]: MUST License field in the package spec file matches the actual license.
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package meets the Packaging Guidelines.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST No %config files under /usr.
[x]: MUST Package does not generates any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Requires correct, justified where necessary.
[!]: MUST Rpmlint output is silent.

rpmlint python-django-horizon-doc-2012.1-0.1.e3.fc17.noarch.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint openstack-dashboard-2012.1-0.1.e3.fc17.noarch.rpm

openstack-dashboard.noarch: W: no-documentation
openstack-dashboard.noarch: E: python-bytecode-inconsistent-mtime /usr/share/openstack-dashboard/local/local_settings.pyc 2012-02-06T20:14:22 /etc/openstack-dashboard/local_settings 2012-02-06T20:14:35
1 packages and 0 specfiles checked; 1 errors, 1 warnings.


rpmlint python-django-horizon-2012.1-0.1.e3.fc17.noarch.rpm

python-django-horizon.noarch: W: no-documentation
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/instances/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/flavors/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/services/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/nova/instances_and_volumes/volumes/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/images/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/quotas/tests.py
python-django-horizon.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/horizon/dashboards/settings/templates/settings/tenant/openrc.sh.template 0644L /bin/bash
1 packages and 0 specfiles checked; 7 errors, 1 warnings.


rpmlint python-django-horizon-2012.1-0.1.e3.fc17.src.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/mrunge/785946/horizon-2012.1~e3.tar.gz :
  MD5SUM this package     : 189c537031386cc7f140784bc124a50a
  MD5SUM upstream package : 189c537031386cc7f140784bc124a50a

[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[!]: SHOULD Dist tag is present.
     Note: Multiple Release tags found
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0:
     http://launchpad.net/horizon/%{release_name}/%{release_name}-%{milestone}/+download/horizon-%{version}~%{release_letter}%{milestone}.tar.gz
     (horizon-%{version}~%{release_letter}%{milestone}.tar.gz) Source1:
     openstack-dashboard.conf (openstack-dashboard.conf)
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Rpmlint output is silent.

rpmlint python-django-horizon-doc-2012.1-0.1.e3.fc17.noarch.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint openstack-dashboard-2012.1-0.1.e3.fc17.noarch.rpm

openstack-dashboard.noarch: W: no-documentation
openstack-dashboard.noarch: E: python-bytecode-inconsistent-mtime /usr/share/openstack-dashboard/local/local_settings.pyc 2012-02-06T20:14:22 /etc/openstack-dashboard/local_settings 2012-02-06T20:14:35
1 packages and 0 specfiles checked; 1 errors, 1 warnings.


rpmlint python-django-horizon-2012.1-0.1.e3.fc17.noarch.rpm

python-django-horizon.noarch: W: no-documentation
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/instances/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/flavors/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/services/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/nova/instances_and_volumes/volumes/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/images/tests.py
python-django-horizon.noarch: E: zero-length /usr/lib/python2.7/site-packages/horizon/dashboards/syspanel/quotas/tests.py
python-django-horizon.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/horizon/dashboards/settings/templates/settings/tenant/openrc.sh.template 0644L /bin/bash
1 packages and 0 specfiles checked; 7 errors, 1 warnings.


rpmlint python-django-horizon-2012.1-0.1.e3.fc17.src.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Issues:
- you should fix your buildreqires:
BuildRequires: openstack-glance
BuildRequires: python-cloudfiles >= 1.7.9.3
BuildRequires: python-dateutil
BuildRequires: python-keystoneclient
BuildRequires: python-novaclient >= 2012.1
BuildRequires: python-quantumclient

I cannot see, why those are required for build.

- You should clean up those zero-length files.
- look at the files in horizon-2012.1/horizon/horizon/utils: they're licensed BSD, not ASL2. They're (basicly copied) from djangoproject.org (as the files state) 

- please take a look onto 
openstack-dashboard.noarch: E: python-bytecode-inconsistent-mtime /usr/share/openstack-dashboard/local/local_settings.pyc 2012-02-06T20:14:22 /etc/openstack-dashboard/local_settings 2012-02-06T20:14:35
this should be fixed.

not approving yet.
Comment 6 Cole Robinson 2012-02-06 15:00:01 EST
Matthias, please see comment 2. I tried to provide justification/confusion for those 2 rpmlint warnings. Let me know what you think of those explanations.

Those packages are required for Build because we generate the docs at build time, and sphinx seems to actually import the python module code in process of generating the docs (yes, completely annoying but non trivial to work around for the time being).

Good spot on the license issue, does that mean I just update the License: tag to specify BSD as well? Or is there more to the process.
Comment 7 Matthias Runge 2012-02-06 15:26:07 EST
license: I'd state this as ASL2 and BSD. You should also comment (in spec), which parts are BSD.

I think, it's really strange to require those at build time, but don't want to argue about that. 


I'd expect you to correct the license field.
 

APPROVED
Comment 8 Cole Robinson 2012-02-06 15:43:56 EST
Agreed, the buildrequires are dumb, I plan on investigating a way to drop it.

Thanks a lot for the review! I'll make that spec change when pushing.
Comment 9 Cole Robinson 2012-02-06 15:46:28 EST
New Package SCM Request
=======================
Package Name: python-django-horizon
Short Description: Django application for talking to Openstack
Owners: crobinso
Branches:
InitialCC:
Comment 10 Jon Ciesla 2012-02-06 19:15:35 EST
Git done (by process-git-requests).
Comment 11 Cole Robinson 2012-02-06 20:10:33 EST
Built now
Comment 12 Pádraig Brady 2012-04-04 19:17:07 EDT
Package Change Request
======================
Package Name: python-django-horizon
New Branches: el6
Owners: crobinso markmc pbrady

This is to support openstack dashboard in the Essex upgrade in EPEL
Comment 13 Jon Ciesla 2012-04-05 08:10:34 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.